////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLVECTOR3_H__5B1A2FED_C6E6_4F00_9060_3E87476DE06D__INCLUDED_)
#define AFX_GLVECTOR3_H__5B1A2FED_C6E6_4F00_9060_3E87476DE06D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <stdlib.h>
#include <GL/glut.h>
#include "importexport.h"
#include <math.h>
class CGL_API  CGLVector3
{
public:
	GLfloat x,y,z;
	CGLVector3():x(0),y(0),z(0){};
	CGLVector3(GLfloat p_fx,GLfloat p_fy,GLfloat p_fz):x(p_fx),y(p_fy),z(p_fz){};
	CGLVector3(const CGLVector3 & p_v3){x=p_v3.x; y=p_v3.y; z=p_v3.z;}

	CGLVector3 operator + (const CGLVector3 & p_v3) {return CGLVector3(x+p_v3.x,y+p_v3.y,z+p_v3.z);};
	CGLVector3 operator - (const CGLVector3 & p_v3) {return CGLVector3(x-p_v3.x,y-p_v3.y,z-p_v3.z);};
	CGLVector3 operator * (const CGLVector3 & p_v3) {return
			CGLVector3(
			y*p_v3.z-z*p_v3.y,
			z*p_v3.x-x*p_v3.z,
			x*p_v3.y-y*p_v3.x);
			};
	GLfloat GetLength(void){	return sqrt(x*x+y*y+z*z);}
	void Normalize(void){GLfloat fLength=GetLength();x/=fLength; y=y/fLength; z/=fLength;}

};

#endif // !defined(AFX_GLVECTOR3_H__5B1A2FED_C6E6_4F00_9060_3E87476DE06D__INCLUDED_)
